import { select, json, geoPath, tsv, transform, zoom,
        geoMercator, geoOrthographic, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

const svg=select('svg');
const height=parseFloat(svg.attr('height'));
const width=parseFloat(svg.attr('width'));

//const projection = geoMercator();
const projection = geoOrthographic();
//const projection = geoNaturalEarth1();

const pathGenerator = geoPath().projection(projection);

Promise.all ([
  json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-50m.json')
]).then(([data]) => {
	const countries = feature(data, data.objects.countries);
	//console.log(data);
 	//console.log(countries);
  //console.log(data.objects.countries.geometries);
		  
  const countryName = data.objects.countries.geometries
  	.reduce((accumulator, d) => {
      accumulator[d.id] = d.properties.name;
      return accumulator;
    }, {});
  
  /*
  const countryName = {};
  data.objects.countries.geometries.forEach(d=> {
    countryName[d.id] = d.properties.name;
  });
  */
  
  //console.log(countryName);
  
  const g = svg.append('g');
  
  svg.call(zoom().on('zoom', ({transform}) => {
    g.attr("transform",transform);
  }));
  
  g.append('path')
  	.attr('class', 'sphere')
  	.attr('d', pathGenerator({type: 'Sphere'}));
  
  g.selectAll('path')
  	.data(countries.features)
  	.enter().append('path')
  		.attr('class', 'country')
  		.attr('d', pathGenerator)
  	.append('title')
  		//.text(d => d.properties.name); 
  		.text(d => countryName[d.id]);
  });